Summary:        Sendmail milter for DKIM
Name:           dkim-milter
Version:        2.1.2
Release:        0%{?dist}
License:        GPL
Group:          System Environment/Daemons
URL:            http://sourceforge.net/projects/dkim-milter/

Source0:        http://prdownloads.sourceforge.net/dkim-milter/%{name}-%{version}.tar.gz
Patch01:        dkim-milter-0.5.1-postfix.patch
Patch02:        dkim-milter-0.5.1-amd64.patch
Patch03:        dkim-milter-0.5.1-ar.patch
Patch04:        dkim-milter-1.1.0-config.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires:  sendmail-devel, openssl
# FIXME: openssl 0.9.8 workround
Autoreq: 0
Requires:       sendmail

Requires(pre):  /usr/sbin/useradd
Requires(post): /sbin/chkconfig
Requires(post): /sbin/service
Requires(preun): /sbin/chkconfig
Requires(preun): /sbin/service
Requires(postun): /sbin/service

%description
The dkim-milter package is an open source implementation of the DKIM
sender authentication system proposed by the E-mail Signing Technology
Group (ESTG).  DKIM is an amalgamation of the DomainKeys (DK) proposal
by Yahoo!, Inc. and the Internet Identified Mail (IIM) proposal by
Cisco.  It consists of a library that implements the DKIM service, and a
milter-based filter application that can plug in to the sendmail MTA to
provide that service to sufficiently recent sendmail MTAs.

%prep
%setup -q
%patch01 -p1 -b .postfix
#%patch02 -p1 -b .amd64
#%patch03 -p1 -b .ar
%patch04 -p0 -b .config

%{__cat} <<'EOF' >dkim-milter.sysconfig
# Default values
#
#USER="dkim-milt"
#PORT="inet:10035@localhost"
#SIGNING_DOMAIN="example.com"
#SELECTOR_NAME="dktest"
#KEYFILE="%{_sysconfdir}/mail/domainkeys/dkim_${SELECTOR_NAME}.pem"
#SIGNER=yes
#VERIFIER=yes
#CANON=simple
#SIGALG=rsa-sha1
#REJECTION="bad=r,dns=t,int=t,no=a,miss=r"
#EXTRA_ARGS="-h -l -D"

# User configuration
#
#PORT0="inet:10034@localhost"
#SIGNER0=no
#PORT1="inet:10035@localhost"
#VERIFIER1=no
#...
EOF

%{__cat} <<'EOF' >dkim-milter.sysv
#!/bin/bash
#
# Init file for DKIM sendmail milter.
#
# chkconfig: - 79 21
# description: dkim-filter is a daemon that hooks into sendmail and \
#              sign/verify mail according DKIM standard
#
# processname: dkim-filter
# config: %{_sysconfdir}/sysconfig/dkim-milter
# pidfile: %{_localstatedir}/run/dkim-milter.pid

source %{_initrddir}/functions
source %{_sysconfdir}/sysconfig/network

# Check that networking is up.
[ ${NETWORKING} = "no" ] && exit 0

[ -x %{_sbindir}/dkim-filter ] || exit 1

### Default variables
USER="dkim-milt"
PORT="inet:10036@localhost"
SIGNING_DOMAIN="example.com"
SELECTOR_NAME="dktest"
KEYFILE="%{_sysconfdir}/mail/domainkeys/dkim_${SELECTOR_NAME}.pem"
SIGNER=yes
VERIFIER=yes
CANON=simple
SIGALG=rsa-sha1
REJECTION="bad=r,dns=t,int=t,no=a,miss=r"
EXTRA_ARGS="-h -l -D"
SYSCONFIG="%{_sysconfdir}/sysconfig/dkim-milter"

### Read configuration
[ -r "$SYSCONFIG" ] && source "$SYSCONFIG"
NUM=0
CMD_ARGS=()
while [ ! -z $(eval "echo \$PORT${NUM}") ]; do
  LPORT=${PORT}
  LSIGNING_DOMAIN=${SIGNING_DOMAIN}
  LSELECTOR_NAME=${SELECTOR_NAME}
  LKEYFILE=${KEYFILE}
  LSIGNER=${SIGNER}
  LVERIFIER=${VERIFIER}
  LCANON=${CANON}
  LSIGALG=${SIGALG}
  LREJECTION=${REJECTION}
  LEXTRA_ARGS=${EXTRA_ARGS}
  [ ! -z $(eval "echo \$PORT${NUM}") ] && LPORT=$(eval "echo \$PORT${NUM}")
  [ ! -z $(eval "echo \$SIGNING_DOMAIN${NUM}") ] && LSIGNING_DOMAIN=$(eval "echo \$SIGNING_DOMAIN${NUM}")
  [ ! -z $(eval "echo \$SELECTOR_NAME${NUM}") ] && LSELECTOR_NAME=$(eval "echo \$SELECTOR_NAME${NUM}")
  [ ! -z $(eval "echo \$KEYFILE${NUM}") ] && LKEYFILE=$(eval "echo \$KEYFILE${NUM}")
  [ ! -z $(eval "echo \$SIGNER${NUM}") ] && LSIGNER=$(eval "echo \$SIGNER${NUM}")
  [ ! -z $(eval "echo \$VERIFIER${NUM}") ] && LVERIFIER=$(eval "echo \$VERIFIER${NUM}")
  [ ! -z $(eval "echo \$CANON${NUM}") ] && LCANON=$(eval "echo \$CANON${NUM}")
  [ ! -z $(eval "echo \$SIGALG${NUM}") ] && LSIGALG=$(eval "echo \$SIGALG${NUM}")
  [ ! -z $(eval "echo \$REJECTION${NUM}") ] && LREJECTION=$(eval "echo \$REJECTION${NUM}")
  [ ! -z $(eval "echo \$EXTRA_ARGS${NUM}") ] && LEXTRA_ARGS=$(eval "echo \$EXTRA_ARGS${NUM}")
  LMODES=
  if [ x${LSIGNER:0:1} == "xy" -o x${LSIGNER:0:1} == "xY" ]; then
    LMODES=${LMODES}s
  fi
  if [ x${LVERIFIER:0:1} == "xy" -o x${LVERIFIER:0:1} == "xY" ]; then
    LMODES=${LMODES}v
  fi
  [ ! -z "$LMODES" ] && LMODES="-b $LMODES"
  CMD_ARGS[${NUM}]="-u $USER -p $LPORT -d $LSIGNING_DOMAIN -k $LKEYFILE -s $LSELECTOR_NAME $LMODES -c $LCANON -S $LSIGALG -C $LREJECTION $LEXTRA_ARGS"
  NUM=$((${NUM}+1))
done
if [ ${#CMD_ARGS[*]} -eq 0 ]; then
  MODES=
  if [ x${SIGNER:0:1} == "xy" -o x${SIGNER:0:1} == "xY" ]; then
    MODES=${MODES}s
  fi
  if [ x${VERIFIER:0:1} == "xy" -o x${VERIFIER:0:1} == "xY" ]; then
    MODES=${MODES}v
  fi
  [ ! -z "$MODES" ] && MODES="-b $MODES"
  CMD_ARGS[0]="-u $USER -p $PORT -d $SIGNING_DOMAIN -k $KEYFILE -s $SELECTOR_NAME $MODES -c $CANON -S $SIGALG -C $REJECTION $EXTRA_ARGS"
fi

RETVAL=0
prog="dkim-filter"
desc="DKIM milter"
#pidfile=%{_localstatedir}/run/dk-milter.pid

start() {
        for ((i=0; $i<${#CMD_ARGS[*]}; i=$(($i+1)) )); do
		pidfile=%{_localstatedir}/run/${prog}${i}.pid
		echo -n $"Starting $desc ($prog #$i): "
		touch $pidfile
		chown $USER $pidfile
                # FIXME: openssl 0.9.8 workround
		daemon --user=root LD_LIBRARY_PATH=/usr/lib/ssl-dkim %{_sbindir}/${prog} ${CMD_ARGS[$i]} -P $pidfile
		RETVAL=$?
		echo
		[ $RETVAL -eq 0 ] && touch %{_localstatedir}/lock/subsys/${prog}${i}
        done
	return $RETVAL
}

stop() {
	echo -n $"Shutting down all $desc ($prog): "
	killproc $prog
	RETVAL=$?
	echo
	if [ $RETVAL -eq 0 ]; then
		for ((i=0; $i<${#CMD_ARGS[*]}; i=$(($i+1)) )); do
			pidfile=%{_localstatedir}/run/${prog}${i}.pid
			echo -n $"Cleanup for $desc ($prog #$i): "
			rm -f %{_localstatedir}/lock/subsys/${prog}${i}
			echo
		done
        fi
	return $RETVAL
}

restart() {
	stop
	sleep 2
	start
}

case "$1" in
  start)
	start
	;;
  stop)
	stop
	;;
  restart|reload)
	restart
	;;
  condrestart)
	[ -e %{_localstatedir}/lock/subsys/${prog} ] && restart
	RETVAL=$?
	;;
  status)
	status $prog
	RETVAL=$?
	;;
  *)
	echo $"Usage: $0 {start|stop|restart|condrestart|status}"
	RETVAL=1
esac

exit $RETVAL
EOF

%build
%{__cp} site.config.m4.dist devtools/Site/site.config.m4
%{__make} %{?_smp_mflags}

%install
%{__rm} -rf %{buildroot}

%{__install} -D -m0755 dkim-milter.sysv %{buildroot}%{_initrddir}/dkim-milter
%{__install} -D -m0644 dkim-milter.sysconfig %{buildroot}%{_sysconfdir}/sysconfig/dkim-milter
%{__install} -d -m0700 %{buildroot}%{_localstatedir}/run/dkim-milter
%{__install} -D -m0664 dkim-filter/dkim-filter.8 %{buildroot}%{_mandir}/man8/dkim-filter.8
%{__install} -D -m0755 obj.`uname -s`.`uname -r`.`uname -p`/dkim-filter/dkim-filter %{buildroot}%{_sbindir}/dkim-filter
%{__strip} %{buildroot}%{_sbindir}/dkim-filter
%{__cp} dkim-filter/README dkim-filter/DKIM_README

%pre
/usr/sbin/useradd -r -s /sbin/nologin -d %{_localstatedir}/run/dkim-milter \
	-c "DKIM Milter" dkim-milt &>/dev/null || :

%post
/sbin/chkconfig --add dkim-milter || :

%preun
if [ $1 -eq 0 ]; then
    /sbin/service dkim-milter stop &>/dev/null || :
    /sbin/chkconfig --del dkim-milter || :
fi

%postun
/sbin/service dkim-milter condrestart &>/dev/null || :

%clean
%{__rm} -rf %{buildroot}

%files
%defattr(-, root, root, 0755)
%doc FEATURES INSTALL KNOWNBUGS LICENSE README RELEASE_NOTES draft-*.txt dkim-filter/DKIM_README dkim-filter/autorespond.csh dkim-filter/dkim-filter.conf.sample dkim-filter/gentxt.csh
%{_mandir}/man8/dkim-filter.8*
%config(noreplace) %{_sysconfdir}/sysconfig/dkim-milter
%{_initrddir}/dkim-milter
%{_sbindir}/dkim-filter
%dir %attr(-,dkim-milt,root) %{_localstatedir}/run/dkim-milter

%changelog
* Fri Jul  8 2006 Petr Vokac <vokac@kmlinux.fjfi.cvut.cz> - 0.5.1-1
- Initial package.
